# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#
%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without jdk6
%bcond_without repolib

%define jar_name jstl
%define jstlver 1.2

%define repodir %{_javadir}/repository.jboss.com/sun-jstl/%{jstlver}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

Name:           glassfish-jstl 
Version:        1.2.0
Release:        12%{?dist}
Epoch:          0
Summary:        GlassFish JSTL
License:        CDDL 1.0
Group:          Development/Java
URL:            http://jstl.dev.java.net/
# cvs -z3 -Q -d:pserver:guest@cvs.dev.java.net:/cvs export -D20060512 -d glassfish-jstl-1.2.0 glassfish/appserv-jstl && tar cjf glassfish-jstl-1.2.0.tar.bz2 glassfish-jstl-1.2.0
Source0:        glassfish-jstl-1.2.0.tar.bz2
Source1:        glassfish-jstl-component-info.xml
Source2:        CDDLv1.0.txt
Source3:        http://repository.jboss.org/maven2/javax/servlet/jstl/1.2/jstl-1.2.pom
Source4:        glassfish-jstl-settings.xml
Source5:        glassfish-jstl-jpp-depmap.xml
Source6:        glassfish-jstl-upload.sh
Patch0:         glassfish-jstl-1.2.0-ant-hack.patch
Patch1:         glassfish-jstl-jdk6.patch
Provides:       jstl = 0:%{jstlver}

BuildRequires:  ant >= 0:1.6.5
BuildRequires:  jbossweb-jsp-2.1-api
BuildRequires:  jbossweb-lib
BuildRequires:  jbossweb-servlet-2.5-api
BuildRequires:  maven2-plugin-deploy

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JavaServer Pages Standard Tag Library.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Provides:       jaf-javadoc = 0:%{jstlver}

%description javadoc
%{summary}.

%prep
%setup -q
%{_bindir}/iconv -f iso88591 -t utf8 < %{SOURCE2} > CDDLv1.0.txt
%patch0 -p1
%if %with jdk6
%patch1 -p1
%endif

cp -p %{SOURCE4} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} -Djavaee.jar=$(build-classpath jbossweb/jsp-api jbossweb/servlet-api jbossweb/el-api) release jar

%install
rm -rf $RPM_BUILD_ROOT

#jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/
install -p -m 0644 build/release/%{jar_name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -p -m 0644 build/jstl.src.zip $RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)
/bin/touch $RPM_BUILD_ROOT%{_javadir}/jstl.jar

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -pm 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap jstl jstl %{version} JPP %{name}
%add_to_maven_depmap javax.servlet jstl %{version} JPP %{name}

# maven
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository
%{_bindir}/mvn-jpp \
-s ${M2SETTINGS} \
-Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
-Dmaven2.jpp.depmap.file=%{SOURCE5} \
deploy:deploy-file -DgroupId=javax.servlet \
-DartifactId=jstl -Dversion=1.2 -Dpackaging=jar -Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar \
-Durl=file://$(pwd)/maven2-brew -DrepositoryId=jboss-releases
# FIXME: deploy seems to ignore classifier
%if 0
%{_bindir}/mvn-jpp \
-s ${M2SETTINGS} \
-Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
-Dmaven2.jpp.depmap.file=%{SOURCE5} \
deploy:deploy-file -DpomFile=$RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom \
-Dfile=$RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar -Dclassifer=sources \
-Durl=file://$(pwd)/maven2-brew -DrepositoryId=jboss-releases
%endif

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadoc/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{jstlver}-brew/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{PATCH1} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom $RPM_BUILD_ROOT%{repodirlib}/jstl.pom
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jstl.jar
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-sources-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jstl-sources.jar
%{__install} -p -m 755 %{SOURCE6} %{buildroot}%{repodir}/upload.sh
pushd $RPM_BUILD_ROOT%{repodir}
./upload.sh $RPM_BUILD_ROOT/usr/share/java/repository.jboss.com/maven2-brew/
popd
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%{_sbindir}/update-alternatives --install %{_javadir}/jstl.jar jstl %{_javadir}/%{name}.jar 10100

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove jstl %{_javadir}/%{name}.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CDDLv1.0.txt
%{_javadir}*/%{name}-%{version}.jar
%{_javadir}*/%{name}.jar
%{_javadir}*/%{name}-sources-%{version}.jar
%{_javadir}*/%{name}-sources.jar
%ghost %{_javadir}*/%{jar_name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Thu Jan 20 2011 Hui Wang <huwang@redhat.com> 0:1.2.0-12
- Rebuild

* Mon Nov 22 2010 Hui Wang <huwang@redhat.com> 0:1.2.0-11
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars

* Wed Jun 09 2010 David Walluck <dwalluck@redhat.com> 0:1.2.0-10.6
- downgrade to 20060512
- add sources jar
- fix pom name
- add depmap

* Wed May 05 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2.0-10.5.1
- rebuilt

* Fri Apr 02 2010 Yong Yang <yyang@redhat.com> 0:1.2.0-10.5
- Replace jbossweb2-* package with jbossweb-*
- Switch to build with jdk6
- Rebuild to generate signed jar

* Fri Nov 27 2009 Martha Benitez <mbenitez@redhat.com> 0:1.2.0-10.4
- Add sed command to fix version and tag in component-info.xml in repolib
- Add sources.zip to repolib
- Add patch1 to repolib

* Mon Aug 24 2009 David Walluck <dwalluck@redhat.com> 0:1.2.0-10.3
- use jstl.pom from repository.jboss.org in repolib

* Mon Aug 24 2009 David Walluck <dwalluck@redhat.com> 0:1.2.0-10.2
- update jbossweb2 BuildRequires
- change repolib version to jstlver
- copy jstl.pom to repolib

* Wed Jun 17 2009 Martha Benitez <mbenitez@redhat.com> 0:1.2.0-10.1
- Change BR jbossweb2 to jbossweb

* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 0:1.2.0-10
- BuildRequires: jbossweb2

* Mon Apr 13 2009 David Walluck <dwalluck@redhat.com> 0:1.2.0-9
- fix repolib
- rename repolib location to sun-jstl to match upstream

* Fri Oct 10 2008 Yong Yang <yyang@redhat.com> 0:1.2.0-8
- apply jdk6 patch

* Tue Jul 22 2008 David Walluck <dwalluck@redhat.com> 0:1.2.0-7
- fix repodir version to include -brew suffix

* Sat Jul 19 2008 David Walluck <dwalluck@redhat.com> 0:1.2.0-6
- fix repodir version

* Fri Jul 18 2008 David Walluck <dwalluck@redhat.com> 0:1.2.0-5
- fix repolib location

* Fri Jul 18 2008 David Walluck <dwalluck@redhat.com> 0:1.2.0-4
- change repolib component id
- fix repolib permissions
- fix maven directory ownership

* Fri Jun 13 2008  David Walluck <dwalluck@redhat.com> 0:1.2.0-3.jpp5
- fix the version in component-info.xml
- fix jar name in repository
- fix %%doc
- fix LICENSE.txt encoding
- mark %%{_mavendepmapfragdir} as %%config(noreplace)
- fix repolib file permissions

* Thu Jun 12 2008 David Walluck <dwalluck@redhat.com> 0:1.2.0-2.jpp5
- fix component info
- remove javadoc post
- use macros

* Tue Jun 03 2008 Permaine Cheung <pcheung@redhat.com> 0:1.2.0-1
- First JPP 5 build

* Tue Nov 27 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.2.0-0jpp.ep1.4
- Adding pom and -brew 

* Tue Nov 27 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.2.0-0jpp.ep1.3
- Build from source.
- Added javadoc.

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.2.0-0jpp.ep1.2
- Mimic sun-jstl repository setup so it can be used as a replacement

* Fri Nov 16 2007 Clive Saldanha <csaldanh@redhat.com> 0:1.2.0-0jpp.ep1.1
- First release.
